<?php
/**
 * Ajax helper for IR GeoData plugin
 * alexey@gnevyshev.ru
 */

// SETTING
$root_path = dirname(dirname(dirname(__DIR__)));

if (!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

// load Joomla
if (!defined('_JEXEC')) {
    define('_JEXEC', 1);
    define('JPATH_BASE', $root_path);
    require_once JPATH_BASE.'/includes/defines.php';
    require_once JPATH_BASE.'/includes/framework.php';
}

$app = JFactory::getApplication('site');
$input = $app->input;
$task = $input->get('task', '', 'cmd');
$url = $input->post->get('download_url', '', 'string');
// $url = 'https://sypexgeo.net/files/SxGeoCity_utf8.zip'; // ВРЕМЕННО


if ($task == 'download' && !empty($url)) {
    
    $dat_file_dir = __DIR__.DS.'sypex_geo'.DS;
    $last_updated_file = __DIR__.DS.'sypex_geo'.DS.'SxGeo.upd';
    $text = 'Обновление базы Sypex Geo (плагин IR GeoData)'.PHP_EOL;
    $text .= 'Ссылка для скачивания: '.$url.PHP_EOL;
    
    require_once __DIR__.DS.'sypex_geo'.DS.'sxgeo_update.php';
    $answer = sxgeo_update($url, $last_updated_file, $dat_file_dir, true);
    
    $answer->txt = $text.$answer->txt;
    $answer->updated = '';
    
    if (!$answer->success) {
        echo json_encode($answer);
        exit();
    }
    
    // обновим в БД дату обновления базы Sypex
    $date_str = file_get_contents(__DIR__.DS.'sypex_geo'.DS.'SxGeo.upd');
    $db = JFactory::getDbo();
    $query = '
        SELECT params
        FROM #__extensions
        WHERE type = "plugin" AND element = "irgeodata"
    ';
    $db->setQuery($query);
    $params = $db->loadResult();
    $params = json_decode($params);
    $params->last_update = $date_str;
    $params = json_encode($params);
    $query = '
        UPDATE #__extensions
        SET params = '.$db->quote($params).'
        WHERE type = "plugin" AND element = "irgeodata"
    ';
    $db->setQuery($query);
    $db->execute();
    
    // передадим в ajax дату обновления
    $answer->updated = $date_str;
    
    echo json_encode($answer);
}
