<?php
/**
* Joomla IR GeoData plugin helper (frontend)
* alexey@gnevyshev.ru
*/
defined( '_JEXEC' ) or die;

function irgd_deleteOldRecords($db_save_period)
{
    $db = JFactory::getDbo();
    $compare_date = (new DateTime('-'.$db_save_period.' days'))->format('Y-m-d H:i:s');
    $query = 'DELETE FROM `#__ir_geodata` WHERE `updated` < "'.$compare_date.'"';
    $db->setQuery($query);
    $db->execute();
}

function irgd_updateParamLastDbClear()
{
    $db = JFactory::getDbo();
    $query = '
        SELECT params
        FROM #__extensions
        WHERE type = "plugin" AND element = "irgeodata"
    ';
    $db->setQuery($query);
    $params = $db->loadResult();
    $params = json_decode($params);
    $params->last_db_clear = date('Y-m-d H:i:s');
    $params = json_encode($params);
    $query = '
        UPDATE #__extensions
        SET params = '.$db->quote($params).'
        WHERE type = "plugin" AND element = "irgeodata"
    ';
    $db->setQuery($query);
    $db->execute();
}

function irgd_getGeoDataFromDb($ip)
{
    $geodata = [];
    $db = JFactory::getDbo();
    $query = 'SELECT * FROM `#__ir_geodata` WHERE `ip` = "'.$ip.'"';
    $db->setQuery($query);
    $result = $db->loadAssoc();
    if (!empty($result)) {
        $geodata['country_id'] = (int) $result['country_id'];
        $geodata['country_iso'] = $result['country_iso'];
        $geodata['country_lat'] = (float) $result['country_lat'];
        $geodata['country_lon'] = (float) $result['country_lon'];
        $geodata['country_name_en'] = $result['country_name_en'];
        $geodata['country_name_ru'] = $result['country_name_ru'];
        $geodata['region_id'] = (int) $result['region_id'];
        $geodata['region_iso'] = $result['region_iso'];
        $geodata['region_name_en'] = $result['region_name_en'];
        $geodata['region_name_ru'] = $result['region_name_ru'];
        $geodata['city_id'] = (int) $result['city_id'];
        $geodata['city_lat'] = (float) $result['city_lat'];
        $geodata['city_lon'] = (float) $result['city_lon'];
        $geodata['city_name_en'] = $result['city_name_en'];
        $geodata['city_name_ru'] = $result['city_name_ru'];
    }
    return $geodata;
}

function irgd_getGeoDataFromSypex($ip)
{
    $geodata = [];
    $dat_path = __DIR__.DS.'sypex_geo'.DS.'SxGeoCity.dat';
    
    if (file_exists($dat_path)) {
        
        require_once __DIR__.DS.'sypex_geo'.DS.'SxGeo.php';
        $SxGeo = new SxGeo($dat_path);
        $data = $SxGeo->getCityFull($ip);
        
        if (!empty($data['country']['id'])) $geodata['country_id'] = (int) $data['country']['id'];
        if (!empty($data['country']['iso'])) $geodata['country_iso'] = $data['country']['iso'];
        if (!empty($data['country']['lat'])) $geodata['country_lat'] = (float) $data['country']['lat'];
        if (!empty($data['country']['lon'])) $geodata['country_lon'] = (float) $data['country']['lon'];
        if (!empty($data['country']['name_en'])) $geodata['country_name_en'] = $data['country']['name_en'];
        if (!empty($data['country']['name_ru'])) $geodata['country_name_ru'] = $data['country']['name_ru'];
        if (!empty($data['region']['id'])) $geodata['region_id'] = (int) $data['region']['id'];
        if (!empty($data['region']['iso'])) $geodata['region_iso'] = $data['region']['iso'];
        if (!empty($data['region']['name_en'])) $geodata['region_name_en'] = $data['region']['name_en'];
        if (!empty($data['region']['name_ru'])) $geodata['region_name_ru'] = $data['region']['name_ru'];
        if (!empty($data['city']['id'])) $geodata['city_id'] = (int) $data['city']['id'];
        if (!empty($data['city']['lat'])) $geodata['city_lat'] = (float) $data['city']['lat'];
        if (!empty($data['city']['lon'])) $geodata['city_lon'] = (float) $data['city']['lon'];
        if (!empty($data['city']['name_en'])) $geodata['city_name_en'] = $data['city']['name_en'];
        if (!empty($data['city']['name_ru'])) $geodata['city_name_ru'] = $data['city']['name_ru'];
    }
    
    return $geodata;
}

function irgd_writeGeoDataForIp($geodata, $ip)
{
    $db = JFactory::getDbo();
    $row = new stdClass();
    $row->ip = $ip;
    foreach ($geodata as $key => $value) {
        $row->$key = $value;
    }
    $insert_result = $db->insertObject('#__ir_geodata', $row);
}

function irgd_replaceConstants()
{
    if (version_compare(JVERSION,'3.0.0','ge')) {
        $app = JFactory::getApplication();
        $html = $app->getBody();
    } else if (version_compare(JVERSION,'2.5.0','ge')) {
        $html = JResponse::getBody();
    }
    if (empty($html)) return false;
    $searches = [];
    $replaces = [];
    if (defined('GEODATA_COUNTRY_ID')) { $searches[] = 'GEODATA_COUNTRY_ID'; $replaces[] = GEODATA_COUNTRY_ID; }
    if (defined('GEODATA_COUNTRY_ISO')) { $searches[] = 'GEODATA_COUNTRY_ISO'; $replaces[] = GEODATA_COUNTRY_ISO; }
    if (defined('GEODATA_COUNTRY_LAT')) { $searches[] = 'GEODATA_COUNTRY_LAT'; $replaces[] = GEODATA_COUNTRY_LAT; }
    if (defined('GEODATA_COUNTRY_LON')) { $searches[] = 'GEODATA_COUNTRY_LON'; $replaces[] = GEODATA_COUNTRY_LON; }
    if (defined('GEODATA_COUNTRY_NAME_EN')) { $searches[] = 'GEODATA_COUNTRY_NAME_EN'; $replaces[] = GEODATA_COUNTRY_NAME_EN; }
    if (defined('GEODATA_COUNTRY_NAME_RU')) { $searches[] = 'GEODATA_COUNTRY_NAME_RU'; $replaces[] = GEODATA_COUNTRY_NAME_RU; }
    if (defined('GEODATA_REGION_ID')) { $searches[] = 'GEODATA_REGION_ID'; $replaces[] = GEODATA_REGION_ID; }
    if (defined('GEODATA_REGION_ISO')) { $searches[] = 'GEODATA_REGION_ISO'; $replaces[] = GEODATA_REGION_ISO; }
    if (defined('GEODATA_REGION_NAME_EN')) { $searches[] = 'GEODATA_REGION_NAME_EN'; $replaces[] = GEODATA_REGION_NAME_EN; }
    if (defined('GEODATA_REGION_NAME_RU')) { $searches[] = 'GEODATA_REGION_NAME_RU'; $replaces[] = GEODATA_REGION_NAME_RU; }
    if (defined('GEODATA_CITY_ID')) { $searches[] = 'GEODATA_CITY_ID'; $replaces[] = GEODATA_CITY_ID; }
    if (defined('GEODATA_CITY_LAT')) { $searches[] = 'GEODATA_CITY_LAT'; $replaces[] = GEODATA_CITY_LAT; }
    if (defined('GEODATA_CITY_LON')) { $searches[] = 'GEODATA_CITY_LON'; $replaces[] = GEODATA_CITY_LON; }
    if (defined('GEODATA_CITY_NAME_EN')) { $searches[] = 'GEODATA_CITY_NAME_EN'; $replaces[] = GEODATA_CITY_NAME_EN; }
    if (defined('GEODATA_CITY_NAME_RU')) { $searches[] = 'GEODATA_CITY_NAME_RU'; $replaces[] = GEODATA_CITY_NAME_RU; }
    $html = str_replace($searches, $replaces, $html);
    if (version_compare(JVERSION,'3.0.0','ge')) {
        $app->setBody($html);
    } else if (version_compare(JVERSION,'2.5.0','ge')) {
        JResponse::setBody($html);
    }
    return true;
}
